package java.lang.invoke;

import java.util.Arrays;
import java.io.Serializable;

public class LambdaMetafactory
{
    public static final int FLAG_SERIALIZABLE = 1;
    public static final int FLAG_MARKERS = 2;
    public static final int FLAG_BRIDGES = 4;
    private static final Class<?>[] EMPTY_CLASS_ARRAY;
    private static final MethodType[] EMPTY_MT_ARRAY;
    
    public LambdaMetafactory() {
    }
    
    public static CallSite metafactory(MethodHandles.Lookup lookup, String s, MethodType methodType, MethodType methodType2, MethodHandle methodHandle, MethodType methodType3) throws LambdaConversionException {
        InnerClassLambdaMetafactory innerClassLambdaMetafactory = new InnerClassLambdaMetafactory(lookup, methodType, s, methodType2, methodHandle, methodType3, false, LambdaMetafactory.EMPTY_CLASS_ARRAY, LambdaMetafactory.EMPTY_MT_ARRAY);
        innerClassLambdaMetafactory.validateMetafactoryArgs();
        return innerClassLambdaMetafactory.buildCallSite();
    }
    
    public static CallSite altMetafactory(MethodHandles.Lookup lookup, String s, MethodType methodType, Object... array) throws LambdaConversionException {
        MethodType methodType2 = (MethodType)array[0];
        MethodHandle methodHandle = (MethodHandle)array[1];
        MethodType methodType3 = (MethodType)array[2];
        int intValue = (int)array[3];
        int n = 4;
        Class[] empty_CLASS_ARRAY;
        if ((intValue & 0x2) != 0x0) {
            int intValue2 = (int)array[n++];
            empty_CLASS_ARRAY = new Class[intValue2];
            System.arraycopy(array, n, empty_CLASS_ARRAY, 0, intValue2);
            n += intValue2;
        }
        else {
            empty_CLASS_ARRAY = LambdaMetafactory.EMPTY_CLASS_ARRAY;
        }
        MethodType[] empty_MT_ARRAY;
        if ((intValue & 0x4) != 0x0) {
            int intValue3 = (int)array[n++];
            empty_MT_ARRAY = new MethodType[intValue3];
            System.arraycopy(array, n, empty_MT_ARRAY, 0, intValue3);
        }
        else {
            empty_MT_ARRAY = LambdaMetafactory.EMPTY_MT_ARRAY;
        }
        int n2 = (intValue & 0x1) != 0x0;
        if (!(n2 == 0)) {
            int assignable = Serializable.class.isAssignableFrom(methodType.returnType());
            for (int length = empty_CLASS_ARRAY.length, i = 0; i < length; ++i) {
                assignable |= Serializable.class.isAssignableFrom(empty_CLASS_ARRAY[i]);
            }
            if (assignable == 0) {
                empty_CLASS_ARRAY = (Class<?>[])Arrays.copyOf(empty_CLASS_ARRAY, empty_CLASS_ARRAY.length + 1);
                empty_CLASS_ARRAY[empty_CLASS_ARRAY.length - 1] = Serializable.class;
            }
        }
        InnerClassLambdaMetafactory o = new InnerClassLambdaMetafactory(lookup, methodType, s, methodType2, methodHandle, methodType3, (boolean)n2, empty_CLASS_ARRAY, empty_MT_ARRAY);
        o.validateMetafactoryArgs();
        return o.buildCallSite();
    }
    
    static {
        EMPTY_CLASS_ARRAY = new Class[0];
        EMPTY_MT_ARRAY = new MethodType[0];
    }
}
